//
// Created by webpigeon on 17/04/22.
//

#ifndef FGGL_GFX_OGL_MODELS_HPP
#define FGGL_GFX_OGL_MODELS_HPP

#include <string>
#include <unordered_map>

#include <fggl/gfx/ogl/backend.hpp>
#include <fggl/ecs3/ecs.hpp>

namespace fgg::gfx::ogl {

	namespace {
		using fggl::ecs3::World;
		using fggl::gfx::Shader;
	}

	class StaticModelRenderer {
		public:
			StaticModelRenderer();
			~StaticModelRenderer() = default;

			void render(World& world) {
				resolveModels();
				renderModels();
			}

		private:
			/**
			 * Attach any missing render tokens to models.
			 */
			void resolveModels();

			/**
			 * Render all visible objects according to their render tokens.
			 */
			void renderModels();

		private:
			std::unordered_map<std::string, std::shared_ptr<Shader>> m_shaders;
	};

}

#endif //FGGL_INCLUDE_FGGL_GFX_OGL_MODELS_HPP
